xquery version "3.0";

declare option exist:serialize "method=xhtml encoding=UTF-8 media-type=text/html indent=no";

import module namespace xrx_example = "http://iu5.bmstu.ru/edu/xrx_example" at "module.xqm";

declare function local:main() as node()
{
<div>    
<table border="1">
<tr>
    <th>{xrx_example:getMessage("index_list_data_name")}</th>
    <th>{xrx_example:getMessage("index_list_data_uri")}</th>
    <th>{xrx_example:getMessage("index_list_actions")}</th>
</tr>
    {
        let $data := doc($xrx_example:DataStorePath)
        for $d in $data//db
        let 
            $id := xs:string($d/id), 
            $name := xs:string($d/name), 
            $uri := xs:string($d/uri) 
        order by $name ascending    
        return 
        <tr>
            <td>{$name}</td>
            <td><a target="_blank" href="{$uri}">{$uri}</a></td>
            
            <td>
                <form class="form_compact" method="post" action="{$xrx_example:EditPath}">
                    <input type="hidden" name="id" value="{$id}" />
                    <button type="submit">{xrx_example:getMessage("form_edit")}</button>
                </form>    
                
                <form class="form_compact" method="post" action="{$xrx_example:DataPath}">
                    <input type="hidden" name="id" value="{$id}" />
                    <input type="hidden" name="del" value="1" />
                    <button type="submit">{xrx_example:getMessage("form_del")}</button>
                </form>    
            </td>
            
        </tr>            
    }
</table>

<p>
<form method="post" action="{$xrx_example:EditPath}">
    <input type="hidden" name="new" value="1" />
    <button type="submit">{xrx_example:getMessage("form_add_new")}</button>
</form>    
</p>

</div>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/>
    <link rel="stylesheet" type="text/css" href="style.css"/>
  </head>
  <body>
    <h1>{xrx_example:getMessage("index_list")}</h1>
    { local:main() }
  </body>
</html> 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)