xquery version "1.0";

(: Импорт стандартных модулей :)
declare namespace request="http://exist-db.org/xquery/request";
declare namespace session="http://exist-db.org/xquery/session";

(: Импорт модулей приложения :)
import module namespace xrx_example = "http://iu5.bmstu.ru/edu/xrx_example" at "module.xqm";

(: Формат в котором результат должен отображаться в браузере :)
declare option exist:serialize "method=xhtml media-type=text/html indent=no";

(: Идентификатор модуля :)
declare variable $module_id {"processor"};
(: Версия модуля :)
declare variable $module_ver {"1.2"};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Список вопросов :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:ShowForm($DataListURI as xs:string, $DataSaveURI as xs:string, $IdParam as xs:string, $NameParam as xs:string) as node()
{
<div>
<form method="post" action="{$DataSaveURI}">
  <table align="center" border="1">
    <tr>	
      <td>Тип процессора:</td>	
      <td>
	    <input type="hidden" name="id" value="{$IdParam}" />	  
	    <input type="text" size="50" name="processor_name" value="{$NameParam}" />
	  </td>	
    </tr>
	<tr>
	  <td colspan="2" align="center">
		<button type="submit">Сохранить</button>
		<button type="button" onclick="window.location='{$DataListURI}'">Отменить</button>
	  </td>
	</tr>
  </table>
</form>	
</div>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Верхний заголовок :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:ShowHeader() as node()
{
<div/>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Нижний заголовок :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:ShowFooter() as node()
{
<div/>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Основная функция :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:main($DataListURI as xs:string, $DataSaveURI as xs:string, $IdParam as xs:string, $NameParam as xs:string) as node()
{
<div>
  {
    (local:ShowHeader()),
    (local:ShowForm($DataListURI, $DataSaveURI, $IdParam, $NameParam)),
    (local:ShowFooter())
  }
</div>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Возвращает наименование для формы редактирования :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:make_name_param($idParam as xs:string, $newParam as xs:string) as xs:string
{
if($idParam != "0")
  then (xs:string(doc(xrx_example:ProcessorsFileName())//processor[@id=$idParam]/processor_name))
  else (xs:string(""))
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Основной запрос :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
let
$newParam := xs:string(request:get-parameter("new","0")),
$idParam := xs:string(request:get-parameter("id","0")),
$DataSaveURI := xrx_example:PathURI_data_save($module_id, $module_ver),
$DataListURI := xrx_example:PathURI_list($module_id, $module_ver),
$IdParam := xrx_example:PathURI_make_id_param($module_id, $idParam, $newParam),
$NameParam := local:make_name_param($idParam, $newParam)
return 
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/>
    <style type="text/css">
      <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="{xrx_example:PathURI_current_css()}"/>
    </style>
  </head>
  <body>
    <h1>Справочник типов процессоров</h1>
    { local:main($DataListURI, $DataSaveURI, $IdParam, $NameParam) }
  </body>
</html> 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)

