xquery version "1.0";

(: Импорт стандартных модулей :)
declare namespace request="http://exist-db.org/xquery/request";
declare namespace response="http://exist-db.org/xquery/response";
declare namespace session="http://exist-db.org/xquery/session";

(: Импорт модулей приложения :)
import module namespace xrx_example = "http://iu5.bmstu.ru/edu/xrx_example" at "module.xqm";

(: Формат в котором результат должен отображаться в браузере :)
declare option exist:serialize "method=xhtml media-type=text/html indent=no";

(: Идентификаторы модулей для создания коллекций :)
declare variable $module_processor_id {"processor"};
declare variable $module_computer_id {"computer"};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Основной запрос :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
let 
  $Computer_CollectionName := xrx_example:PathURI_data_list_in_db_not_basepath($module_computer_id),
  $Processor_CollectionName := xrx_example:PathURI_data_list_in_db_not_basepath($module_processor_id),
  $Processor_CollectionNameWithBasePath := xrx_example:PathURI_data_list_in_db($module_processor_id)
return
(
  (<h1 align="center">Инициализация БД</h1>),
  (: Создание коллекции iu5 в коллекции /db :)
  xrx_example:InitDB_Create_Collection($xrx_example:BasePath_db, $xrx_example:BasePath_iu5),
  (: Создание коллекции xrx_example в коллекции /db/iu5/ :)
  xrx_example:InitDB_Create_Collection($xrx_example:BasePath_db_iu5, $xrx_example:BasePath_xrx_example),
  (: Создание коллекции computers в коллекции /db/iu5/xrx_example/ :) 
  xrx_example:InitDB_Create_Collection($xrx_example:BasePath, $Computer_CollectionName),
  (: Создание коллекции processors в коллекции /db/iu5/xrx_example/ :)
  xrx_example:InitDB_Create_Collection($xrx_example:BasePath, $Processor_CollectionName),

  (: Создание файла log.xml (для отладочных сообщений) в коллекции /db/iu5/xrx_example/ :)
  xrx_example:InitDB_Create_File($xrx_example:BasePath, $xrx_example:FileName_log, <root/>),
  (: Создание файла processors.xml (процессоры) в коллекции /db/iu5/xrx_example/processors/ :)
  xrx_example:InitDB_Create_File($Processor_CollectionNameWithBasePath, $xrx_example:FileName_processors, <processors/>),
  (
  <div>
    <hr/>
    <table align="center">
      <tr>	
	    {xrx_example:PathURI_menu()}
      </tr>
    </table>
  </div>
  )
)
