xquery version "1.0";

(: Импорт стандартных модулей :)
declare namespace request="http://exist-db.org/xquery/request";
declare namespace session="http://exist-db.org/xquery/session";

(: Импорт модулей приложения :)
import module namespace xrx_example = "http://iu5.bmstu.ru/edu/xrx_example" at "module.xqm";

(: Формат в котором результат должен отображаться в браузере :)
declare option exist:serialize "method=xhtml media-type=text/html indent=no";

(: Идентификатор модуля :)
declare variable $module_id {"processor"};
(: Версия модуля :)
declare variable $module_ver {"1.2"};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(:  Вывод данных в виде списка  :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:ShowList() as node()
{
<div>
  <table align="center" border="1">
    <tr>	
      <th>Тип процессора</th>	
      <th colspan="2">Действия</th>	
    </tr>
    {
      let $ProcessorsDoc := doc(xrx_example:ProcessorsFileName())
      for $Processor in $ProcessorsDoc//processor
      let 
        $id := xs:string($Processor/@id), 
        $nm := xs:string($Processor/processor_name)
      order by $nm
      return 
      <tr>
        <td>{$nm}</td>
        {xrx_example:PathURI_edit_id_form($module_id, $module_ver, $id)}
        {xrx_example:PathURI_delete_id_form($module_id, $module_ver, $id)}	
      </tr>
    }
  </table>
</div>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Верхний заголовок :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:ShowHeader() as node()
{
<div>
  <table>
    <tr>	
	  {xrx_example:PathURI_menu()}
      {xrx_example:PathURI_edit_new_form($module_id, $module_ver)}
    </tr>
  </table>
  <hr/>
</div>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Нижний заголовок :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:ShowFooter() as node()
{
<div/>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Основная функция :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
declare function local:main() as node()
{
<div>
  {
    (local:ShowHeader()),
    (local:ShowList()),
    (local:ShowFooter())
  }
</div>
};

(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
(: Основной запрос :) 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/>
    <style type="text/css">
      <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="{xrx_example:PathURI_current_css()}"/>
    </style>
  </head>
  <body>
    <h1>Справочник типов процессоров</h1>
    { local:main() }
  </body>
</html> 
(: ++++++++++++++++++++++++++++++++++++++++++++++ :)

