<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:param name="report_format" select="string('table')"/> 

<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  -->
<!-- Шаблон обработки корневого элемента XML - документа -->
<xsl:template match="/">
  <div>
    <xsl:apply-templates/>
  </div>
</xsl:template>
<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  -->

<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  -->
<xsl:template match="report_data">

	<xsl:choose>
		<xsl:when test="$report_format='table'">
			<table border="1">
				<tr>	
					<th>Наименование</th>
					<th>Тип процессора</th>
					<th>Объем ОП (в Мб)</th>
					<th>Объем жесткого диска (в Гб)</th>
					<th>Используется как сервер</th>
					<th>Обновления</th>
				</tr>
				
				<xsl:for-each select="computer">
					<tr>	
						<td><xsl:value-of select="computer_name"/></td>
						<td><xsl:value-of select="processor_name"/></td>
						<td><xsl:value-of select="op"/></td>
						<td><xsl:value-of select="hdd"/></td>
						<td>
							<xsl:choose>
								<xsl:when test="server[.='true']">Да</xsl:when>
								<xsl:otherwise>Нет</xsl:otherwise>
							</xsl:choose>
						</td>
						<td><xsl:apply-templates select="upgrades"/></td>
					</tr>				
				</xsl:for-each>
			</table>			
		</xsl:when>
				
		<xsl:otherwise>
			<ol>
				<xsl:for-each select="computer">
					<li>	
						<p>Наименование: <b><xsl:value-of select="computer_name"/></b></p>
						<p>Тип процессора: <b><xsl:value-of select="processor_name"/></b></p>
						<p>Объем ОП (в Мб): <b><xsl:value-of select="op"/></b></p>
						<p>Объем жесткого диска (в Гб): <b><xsl:value-of select="hdd"/></b></p>
						<p>Используется как сервер: <b>
							<xsl:choose>
								<xsl:when test="server[.='true']">Да</xsl:when>
								<xsl:otherwise>Нет</xsl:otherwise>
							</xsl:choose></b>
						</p>
						<p><xsl:apply-templates select="upgrades"/></p>
					</li>				
				</xsl:for-each>			
			</ol>
		</xsl:otherwise>
	</xsl:choose>
	
</xsl:template>
<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  -->

<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  -->
<xsl:template match="upgrades">

	<xsl:choose>
		<xsl:when test="$report_format='table'">
		
			<xsl:choose>
				<xsl:when test="count(upgrade[upgrade_date and upgrade_description]) &gt; 0">
		
					<table border="1">
						<tr>	
							<th>Дата</th>
							<th>Описание</th>
						</tr>
				
						<xsl:for-each select="upgrade[upgrade_date and upgrade_description]">
						<tr>	    
							<td><xsl:value-of select="upgrade_date"/></td>
							<td><xsl:value-of select="upgrade_description"/></td>
						</tr>				
						</xsl:for-each>
					</table>			
				</xsl:when>
				
				<xsl:otherwise>
					<p>Нет обновлений</p>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
				
		<xsl:otherwise>
			<xsl:if test="count(upgrade[upgrade_date and upgrade_description]) &gt; 0">
				<p>Список обновлений:</p>
				<ol>
					<xsl:for-each select="upgrade[upgrade_date and upgrade_description]">
						<li><b><xsl:value-of select="upgrade_date"/> (<xsl:value-of select="upgrade_description"/>)</b></li>				
					</xsl:for-each>
				</ol>			
			</xsl:if>
		
		</xsl:otherwise>
	</xsl:choose>
	
</xsl:template>
<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  -->

</xsl:stylesheet>
